#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const mustache_1 = __importDefault(require("mustache"));
const partial_lookup_js_1 = require("../partial-lookup.js");
const sidecar_metadata_fixture_js_1 = require("../../../tests/fixtures/sidecar-metadata.fixture.js");
const mod_js_1 = require("../../wrappers/mod.js");
(0, tstest_1.test)('native-functions.mustache', async (t) => {
    const SIDECAR_METADATA = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    const view = (0, mod_js_1.wrapView)(SIDECAR_METADATA);
    // console.log(view.nativeFunctionList)
    const template = await (0, partial_lookup_js_1.partialLookup)('native-functions.mustache');
    // console.log(template)
    const result = mustache_1.default.render(template, view);
    /**
     * Huan(202106): how could we test this script has been correctly generated?
     */
    t.ok(result, 'should render to the right script (TBW)');
});
//# sourceMappingURL=native-functions.spec.js.map