#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const metadata_ret_type_js_1 = require("./metadata-ret-type.js");
(0, tstest_1.test)('update & get ret type metadata', async (t) => {
    const PROPERTY_KEY = 'key';
    const TARGET = {
        [PROPERTY_KEY]: () => { },
    };
    const VALUE = ['pointer', 'Utf8String'];
    (0, metadata_ret_type_js_1.updateMetadataRetType)(TARGET, PROPERTY_KEY, VALUE);
    const data = (0, metadata_ret_type_js_1.getMetadataRetType)(TARGET, PROPERTY_KEY);
    t.same(data, VALUE, 'should get the ret type data the same as we set(update)');
});
//# sourceMappingURL=metadata-ret-type.spec.js.map