#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const function_target_js_1 = require("./function-target.js");
(0, tstest_1.test)('PointerType typing', async (t) => {
    const typeTest = true;
    t.ok(typeTest, 'PointerType should be typing right');
});
(0, tstest_1.test)('NativeType typing', async (t) => {
    const typeTest = true;
    t.ok(typeTest, 'NativeType should be typing right');
});
(0, tstest_1.test)('TargetType typing', async (t) => {
    const typeTest = true;
    t.ok(typeTest, 'TargetType should be typing right');
});
(0, tstest_1.test)('ScriptMessageHandler typing', async (t) => {
    const handler = {};
    const typeTest = true;
    t.ok(typeTest, 'ScriptMessageHandler should be typing right');
});
(0, tstest_1.test)('normalizeFunctionTarget()', async (t) => {
    const TEST_LIST = [
        [
            'stringTarget',
            { funcName: 'stringTarget', type: 'agent' },
        ],
        [
            0x42,
            { address: '0x42', moduleName: null, type: 'address' },
        ],
    ];
    const result = TEST_LIST.map(pair => pair[0]).map(function_target_js_1.normalizeFunctionTarget);
    const expected = TEST_LIST.map(pair => pair[1]);
    t.same(result, expected, 'should normalize function target as expected');
});
//# sourceMappingURL=frida.spec.js.map