"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.normalizeFunctionTarget = exports.exportTarget = exports.agentTarget = exports.addressTarget = void 0;
const addressTarget = (address, moduleName = null) => ({
    address: `0x${Number(address).toString(16)}`,
    moduleName,
    type: 'address',
});
exports.addressTarget = addressTarget;
const agentTarget = (funcName) => ({
    funcName,
    type: 'agent',
});
exports.agentTarget = agentTarget;
const exportTarget = (exportName, moduleName = null) => ({
    exportName,
    moduleName,
    type: 'export',
});
exports.exportTarget = exportTarget;
/**
 * Convert the `string` and `number` type target to Obj
 */
function normalizeFunctionTarget(target) {
    if (typeof target === 'number') {
        return addressTarget(target);
    }
    else if (typeof target === 'string') {
        return agentTarget(target);
    }
    return target;
}
exports.normalizeFunctionTarget = normalizeFunctionTarget;
//# sourceMappingURL=function-target.js.map