"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsArgs = void 0;
const name_helpers_js_1 = require("./name-helpers.js");
function jsArgs() {
    const typeList = this.paramTypeList;
    if (!typeList) {
        throw new Error('no .paramTypeList found in SidecarMetadataFunctionDescription!');
    }
    const wrappedArgList = [];
    for (const [idx, typeChain] of typeList.entries()) {
        const [nativeType, ...pointerTypeList] = typeChain;
        // console.log(nativeType, pointerTypeList)
        const readChain = [
            (0, name_helpers_js_1.argName)(idx),
        ];
        /**
         * 1. native pointer
         */
        if (nativeType === 'pointer') {
            for (const pointerType of pointerTypeList) {
                readChain.push(`.read${pointerType}()`);
            }
        }
        wrappedArgList.push(readChain.join(''));
    }
    return '[ ' + wrappedArgList.join(', ') + ' ]';
}
exports.jsArgs = jsArgs;
//# sourceMappingURL=js-args.js.map