#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const sidecar_metadata_fixture_js_1 = require("../../tests/fixtures/sidecar-metadata.fixture.js");
const js_args_js_1 = require("./js-args.js");
(0, tstest_1.test)('jsArgs()', async (t) => {
    const SIDECAR_METADATA = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    const nativeFunctionList = SIDECAR_METADATA.nativeFunctionList;
    const interceptorFunctionList = SIDECAR_METADATA.interceptorList;
    const EXPECTED_ARGS_LIST = [
        '[ args[0].readInt(), args[1].readPointer().readUtf8String() ]',
        '[ args[0].readUtf8String(), args[1] ]',
        '[ args[0] ]',
        '[  ]',
        '[  ]',
        '[ args[0], args[1].readUtf8String() ]',
    ];
    const result = [
        ...nativeFunctionList,
        ...interceptorFunctionList,
    ].map(x => Object.values(x))
        .flat()
        .map(x => js_args_js_1.jsArgs.call(x));
    t.same(result, EXPECTED_ARGS_LIST, 'should wrap the args correct');
});
//# sourceMappingURL=js-args.spec.js.map