#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const sidecar_metadata_fixture_js_1 = require("../../tests/fixtures/sidecar-metadata.fixture.js");
const js_ret_js_1 = require("./js-ret.js");
(0, tstest_1.test)('jsRet()', async (t) => {
    const SIDECAR_VIEW = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    const nativeFunctionList = SIDECAR_VIEW.nativeFunctionList.map(x => Object.values(x)).flat();
    const EXPECTED_RET_LIST = [
        'ret.readPointer().readInt()',
        'ret.readPointer().readUtf8String()',
        'ret',
        'undefined /* void */',
        'ret',
    ];
    const result = nativeFunctionList
        .map(x => js_ret_js_1.jsRet.call(x));
    // console.log(result)
    t.same(result, EXPECTED_RET_LIST, 'should wrap the ret correct');
});
//# sourceMappingURL=js-ret.spec.js.map