#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const sidecar_metadata_fixture_js_1 = require("../../tests/fixtures/sidecar-metadata.fixture.js");
const native_args_js_1 = require("./native-args.js");
(0, tstest_1.test)('nativeArgs()', async (t) => {
    const fixture = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    // console.log(fixture.nativeFunctionList.length)
    const result = fixture.nativeFunctionList
        .map(x => Object.values(x))
        .flat()
        .map(x => native_args_js_1.nativeArgs.call(x));
    const EXPECTED_RESULT = [
        '[ anotherCall_NativeArg_0, anotherCall_NativeArg_1 ]',
        '[ testMethod_NativeArg_0, testMethod_NativeArg_1 ]',
        '[ pointerMethod_NativeArg_0 ]',
        '[  ]',
        '[  ]',
    ];
    t.same(result, EXPECTED_RESULT, 'should list the native arg names correctly.');
});
//# sourceMappingURL=native-args.spec.js.map