#!/usr/bin/env -S node --no-warnings --loader ts-node/esm
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tstest_1 = require("tstest");
const sidecar_metadata_fixture_js_1 = require("../../tests/fixtures/sidecar-metadata.fixture.js");
const native_param_types_js_1 = require("./native-param-types.js");
(0, tstest_1.test)('nativeParamTypes()', async (t) => {
    const fixture = (0, sidecar_metadata_fixture_js_1.getSidecarMetadataFixture)();
    // console.log(JSON.stringify(fixture.nativeFunctionList, null, 2))
    const result = fixture.nativeFunctionList
        .map(x => Object.values(x))
        .flat()
        .map(x => native_param_types_js_1.nativeParamTypes.call(x));
    // console.log(result)
    const EXPECTED_RESULT = [
        "[ 'pointer', 'pointer' ]",
        "[ 'pointer', 'int' ]",
        "[ 'pointer' ]",
        '[]',
        '[]',
    ];
    t.same(result, EXPECTED_RESULT, 'should list the native param types correctly.');
});
//# sourceMappingURL=native-param-types.spec.js.map