/// <reference types="node" />
import vm from 'vm';
/**
 * Huan(202109): adding experimental vm classes/methods
 *
 * importModuleDynamically for vm module is cached #36351
 *  https://github.com/nodejs/node/issues/36351
 */
declare module 'vm' {
    interface SourceTextModuleOptions {
        importModuleDynamically: (specifier: string, module?: any) => any;
        context?: vm.Context;
    }
    type Linker = (specifier: string, extra: Object, referencingModule: any) => any;
    class SourceTextModule {
        constructor(code: string, options?: SourceTextModuleOptions);
        link(linker: Linker): Promise<void>;
        evaluate(): Promise<void>;
    }
}
declare function executeWithContext<T>(code: string, contextObj: object): Promise<undefined | T>;
export { vm, executeWithContext, };
export default vm;
//# sourceMappingURL=vm.d.ts.map