import vm from 'vm';
const importModuleDynamically = (identifier) => import(identifier);
async function executeWithContext(code, contextObj) {
    let __ret;
    /**
     * Huan(202109): Reflect is needed for importModuleDynamically
     */
    const context = vm.createContext({
        Reflect,
        console,
        ...contextObj,
        __ret,
    });
    const assignRetCode = `__ret = await ${code}`;
    const module = new vm.SourceTextModule(assignRetCode, {
        context,
        importModuleDynamically,
    });
    await module.link(() => { });
    await module.evaluate();
    return context['__ret'];
}
export { vm, executeWithContext, };
export default vm;
//# sourceMappingURL=vm.js.map