import { log, } from '../../config.js';
import { RET_TYPE_SYMBOL } from './constants.js';
function updateMetadataRetType(target, propertyKey, typeChain) {
    log.verbose('Sidecar', 'updateMetadataRetType(%s, %s, %s)', target.name, propertyKey, JSON.stringify(typeChain));
    // Update the parameter names
    Reflect.defineMetadata(RET_TYPE_SYMBOL, typeChain, target, propertyKey);
}
function getMetadataRetType(target, propertyKey) {
    // Pull the array of parameter names
    const retTypeChain = Reflect.getMetadata(RET_TYPE_SYMBOL, target, propertyKey);
    return retTypeChain;
}
export { getMetadataRetType, updateMetadataRetType, };
//# sourceMappingURL=metadata-ret-type.js.map