const addressTarget = (address, moduleName = null) => ({
    address: `0x${Number(address).toString(16)}`,
    moduleName,
    type: 'address',
});
const agentTarget = (funcName) => ({
    funcName,
    type: 'agent',
});
const exportTarget = (exportName, moduleName = null) => ({
    exportName,
    moduleName,
    type: 'export',
});
/**
 * Convert the `string` and `number` type target to Obj
 */
function normalizeFunctionTarget(target) {
    if (typeof target === 'number') {
        return addressTarget(target);
    }
    else if (typeof target === 'string') {
        return agentTarget(target);
    }
    return target;
}
export { addressTarget, agentTarget, exportTarget, normalizeFunctionTarget, };
//# sourceMappingURL=function-target.js.map