import type TypedEventEmitter from 'typed-emitter';
import type { SidecarPayloadHook } from './payload-schemas.js';
export declare type SymbolEventListener = () => void;
export declare type HookEventListener = (payload: SidecarPayloadHook['payload']) => void;
export declare type ErrorEventListener = (e: Error) => void;
interface SidecarEvents {
    [symbol: symbol]: SymbolEventListener;
    error: ErrorEventListener;
    hook: HookEventListener;
}
declare type SidecarEmitterType = new () => TypedEventEmitter<SidecarEvents>;
declare const SidecarEmitter: SidecarEmitterType;
export { SidecarEmitter };
//# sourceMappingURL=sidecar-emitter.d.ts.map